package model

import (
	"time"
)

type LuckyDrawRotaryTableUserChance struct {
	Id         int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Uid        int       `json:"uid" xorm:"not null INT(11)"`
	Title      string    `json:"title" xorm:"not null comment('描述') VARCHAR(255)"`
	Pvd        int       `json:"pvd" xorm:"not null default 1 comment('来源:(1虚拟货币购买2订单购买3下单任务获取4分享任务获取)') INT(11)"`
	State      int       `json:"state" xorm:"not null default 1 comment('状态：1未消耗2已消耗') INT(11)"`
	OrdId      int64     `json:"ord_id" xorm:"comment('订单id') BIGINT(22)"`
	OrdAmount  string    `json:"ord_amount" xorm:"not null default 0.0000 comment('订单金额') DECIMAL(12,4)"`
	CoinId     int       `json:"coin_id" xorm:"comment('虚拟币id') INT(11)"`
	CoinAmount string    `json:"coin_amount" xorm:"not null default 0.0000 comment('消耗的虚拟币数量') DECIMAL(12,4)"`
	CreateTime time.Time `json:"create_time" xorm:"created not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateTime time.Time `json:"update_time" xorm:"updated not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
}
