package db

import (
	commDb "applet/app/db"
	"applet/app/flexible_employment/db/model"
	"applet/app/utils/logx"
	"xorm.io/xorm"
)

type NewFlexibleEmploymentPupiaoOrdDb struct {
	Db *xorm.Engine `json:"model"`
}

func (newFlexibleEmploymentPupiaoOrdDb *NewFlexibleEmploymentPupiaoOrdDb) Set(masterId string) { // set方法
	newFlexibleEmploymentPupiaoOrdDb.Db = commDb.DBs[masterId]
}

func (newFlexibleEmploymentPupiaoOrdDb *NewFlexibleEmploymentPupiaoOrdDb) Get(outBatchNo string) (*model.NewFlexibleEmploymentPupiaoOrd, error) {
	var m model.NewFlexibleEmploymentPupiaoOrd
	has, err := newFlexibleEmploymentPupiaoOrdDb.Db.Where("out_batch_no = ?", outBatchNo).Get(&m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return &m, nil
}

func (newFlexibleEmploymentPupiaoOrdDb *NewFlexibleEmploymentPupiaoOrdDb) Update(id interface{}, m *model.NewFlexibleEmploymentPupiaoOrd, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = newFlexibleEmploymentPupiaoOrdDb.Db.Where("id=?", id).Cols(forceColums...).Update(m)
	} else {
		affected, err = newFlexibleEmploymentPupiaoOrdDb.Db.Where("id=?", id).Update(m)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}
