package consume

import (
	"applet/app/db"
	"applet/app/utils/logx"
	"applet/consume/md"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_es.git/utils"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule/service_award_dividend"
	md2 "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule/service_award_dividend/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"strings"
)

func CanalServiceAwardDividendRelationConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1000)
	delivery := ch.Consume(queue.Name, true) //设置自动应答

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>>>CanalServiceAwardDividendRelationConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			handleCanalServiceAwardDividendRelationConsume(res.Body)
			//_ = res.Reject
			//_ = res.Ack(true)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleCanalServiceAwardDividendRelationConsume(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.CanalServiceAwardDividendRelationMessage[md.CanalServiceAwardDividendRelation]
	err := json.Unmarshal(msg, &canalMsg)
	if err != nil {
		fmt.Println("err::::", err.Error())
		return err
	}
	if canalMsg.Type != md.CanalMsgUpdateSqlType {
		return nil
	}
	masterId := strings.Split(canalMsg.Database, "_")[1]
	if masterId != "71353282" {
		return nil
	}

	if len(canalMsg.Old) > 0 && canalMsg.Old[0].VipLevel != "" && canalMsg.Old[0].VipLevel != canalMsg.Data[0].VipLevel {
		eg := db.DBs[masterId]
		//TODO::删除旧的记录
		var parentServiceAwardDividendRelation models.ServiceAwardDividendRelation
		_, err1 := eg.Where("uid = ?", canalMsg.Data[0].BindUid).Get(&parentServiceAwardDividendRelation)
		if err1 != nil {
			return err1
		}
		parentServiceAwardDividendRelation.AllocationNums--
		_, err1 = eg.Where("id=?", parentServiceAwardDividendRelation.Id).Cols("allocation_nums").Update(&parentServiceAwardDividendRelation)
		if err1 != nil {
			return err1
		}

		_, err = eg.Where("id = ?", canalMsg.Data[0].Id).Delete(models.ServiceAwardDividendRelation{})
		if err != nil {
			fmt.Println("err::::", err.Error())
			return err
		}

		err = service_award_dividend.JoinServiceAwardDividendRelation(eg, md2.JoinServiceAwardDividendRelationReq{
			MasterId:       masterId,
			Uid:            zhios_order_relate_utils.StrToInt(canalMsg.Data[0].Uid),
			ParentUid:      zhios_order_relate_utils.StrToInt(canalMsg.Data[0].ParentUid),
			RegionId:       zhios_order_relate_utils.StrToInt(canalMsg.Data[0].RegionId),
			CreateAt:       canalMsg.Data[0].CreateAt,
			AllocationNums: zhios_order_relate_utils.StrToInt(canalMsg.Data[0].AllocationNums),
		})
		if err != nil {
			fmt.Println("err::::", err.Error())
			return err
		}
	}

	return nil
}
