package consume

import (
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"time"
)

//自动升级
func ZhiosUserRegGive(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1000)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			//fmt.Println(string(res.Body))
			fmt.Println(">>>>>>>>>>>>>>>>CanalOrderConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleZhiosUserRegGive(res.Body)
			//_ = res.Reject(false)
			fmt.Println(err)
			_ = res.Ack(true)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleZhiosUserRegGive(msg []byte) error {
	//1、解析canal采集至mq中queue的数据结构体
	var canalMsg *md.ZhiosAcquisition
	fmt.Println(string(msg))
	var tmpString string
	err := json.Unmarshal(msg, &tmpString)
	if err != nil {
		fmt.Println(err.Error())
		return err
	}
	fmt.Println(tmpString)
	err = json.Unmarshal([]byte(tmpString), &canalMsg)
	if err != nil {
		return err
	}
	mid := canalMsg.Mid
	eg := db.DBs[mid]
	if eg == nil {
		return nil
	}
	var setting model.LuckyDrawRotaryTableSetting
	get, _ := eg.Get(&setting)
	if get == false {
		return nil
	}
	chanceRule := md.ChanceRule{}
	json.Unmarshal([]byte(setting.ChanceRule), &chanceRule)
	if chanceRule.NewUserIsOpen != "1" || utils.StrToInt(chanceRule.NewUserCount) == 0 {
		return nil
	}
	profile, _ := db.UserProfileFindByID(eg, canalMsg.Uid)
	if profile == nil {
		return nil
	}
	if profile.ParentUid == 0 {
		return nil
	}
	canalMsg.Uid = utils.IntToStr(profile.ParentUid)
	sess := eg.NewSession()
	defer sess.Close()
	sess.Begin()
	var numData model.UserInviteNum
	b, _ := sess.Where("uid=?", canalMsg.Uid).Get(&numData)
	isNew := 0
	if b == false {
		isNew = 1
		numData = model.UserInviteNum{
			Uid: utils.StrToInt(canalMsg.Uid),
		}
		insert, _ := sess.Insert(&numData)
		if insert == 0 {
			sess.Rollback()
			return errors.New("失败")
		}
	}
	numData.Num++
	num := 0
	if numData.Num >= utils.StrToInt(chanceRule.NewUserCount) {
		num = numData.Num / utils.StrToInt(chanceRule.NewUserCount)
		numData.Num -= utils.StrToInt(chanceRule.NewUserCount) * num
	}
	if num > 0 && utils.StrToInt(chanceRule.NewUserNum) > 0 {
		update, err := sess.Where("id=?", numData.Id).Cols("num").Update(&numData)
		fmt.Println(err)
		if update == 0 && isNew == 0 {
			sess.Rollback()
			return errors.New("失败")
		}
		for i := 0; i < num*utils.StrToInt(chanceRule.NewUserNum); i++ {
			var tmp = model.LuckyDrawRotaryTableUserChance{
				Uid:        utils.StrToInt(canalMsg.Uid),
				Title:      "邀请好友赠送",
				Pvd:        5,
				State:      1,
				CreateTime: time.Now(),
				UpdateTime: time.Now(),
			}
			insert, _ := sess.Insert(&tmp)
			if insert == 0 {
				sess.Rollback()
				return errors.New("失败")
			}
		}
	}
	sess.Commit()
	return nil
}
